Subject: Re: [netconf] IETF109, YANG Push, udp-notif , distributed-notif, data-export-capabilities, notification-messages and adaptive-subscription

From: Qin Wu <[email-masked]>
Date: Tue, 9 Mar 2021 02:29:27 +0000

Hi, Folks:
Based on chairs’ suggestion, Here is the summary of our discussion with Thomas on  data-export-capabilities, and adaptive-subscription drafts.
Thanks Thomas to setup the discussion on YANG Push, udp-notif ,distributed-notif, data-export-capabilities, notification-messages and adaptive-subscription before IETF 110.

1.       Based on our discussion, it was agreed to replace “udp” transport with “udp notif” and “https-notif” two new transports and add references to draft-ietf-netconf-udp-notif-01 and draft-ietf-netconf-https-notif-06 respectively.

These changes have already been incorporated in v-03 of data-export-capabilities draft.

2.       It was agreed that two approaches can be investigated to mitigate the data congestion between data exporter(i.e., server) and collector (i.e., client)

a.       One is to populate adaptive subscription policy on the server (i.e., the device) and allow server automatically switch export rate or data collection rate based on resource change.

b.       The second is to detect the loss between the server and client and leverage RFC8639 capability to trigger the NMS to re-adjust YANG push subscription
For (a), the server also can send export rate change notification to the client about export rate change and trigger the NMS to re-adjust YANG push subscription. This notification has already been supported by adaptive-subscription draft.
      Based on this discussion, we update the abstract and introduction of v-03 of adaptive-subscription. to reflect our discussion points. I believe some of changes will also be reflected in the update of udp-notif ,distributed-notif drafts.

-Qin (on behalf of the team)
发件人: [email-masked] [mailto:[email-masked]]
发送时间: 2021年1月24日 0:19
收件人: Qin Wu <[email-masked]>; Tianran Zhou <[email-masked]>
抄送: [email-masked]; [email-masked]; maqiufang (A) <[email-masked]>
主题: RE: IETF109, YANG Push, udp-notif ,distributed-notif, data-export-capabilities, notification-messages and adaptive-subscription

Hi Qin and Tianran,

> It is the job of the NMS rather than collector to modify the subscription or populate adaptive subscription policy.
You are both correct. The job of the data-collection, is to detect loss between data export and collection and provide the metrics to the NMS which in turn maintains/re-adjust the YANG push subscription. Therefor we have two approaches to mitigate data congestion between data export and collection. One by re-adjusting the subscription with adaptive-subscription based on meta data on the data-export (cpu load, bandwidth, delay etc.), the other with rfc8639 based on meta data on the data-collection.

Pierre: forget what I wrote 😊

Best Wishes
Thomas

From: Qin Wu <[email-masked]<mailto:[email-masked]>>
Sent: Tuesday, January 19, 2021 2:29 PM
To: Tianran Zhou <[email-masked]<mailto:[email-masked]>>; Graf Thomas, INI-NET-TCZ-ZH1 <[email-masked]<mailto:[email-masked]>>
Cc: [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>; maqiufang (A) <[email-masked]<mailto:[email-masked]>>
Subject: RE: IETF109, YANG Push, udp-notif ,distributed-notif, data-export-capabilities, notification-messages and adaptive-subscription

发件人: Tianran Zhou
发送时间: 2021年1月19日 16:17
收件人: [email-masked]<mailto:[email-masked]>; Qin Wu <[email-masked]<mailto:[email-masked]>>
抄送: [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>; maqiufang (A) <[email-masked]<mailto:[email-masked]>>
主题: RE: IETF109, YANG Push, udp-notif ,distributed-notif, data-export-capabilities, notification-messages and adaptive-subscription

Ø  [Qin]: I think you are referred to adaptive-subscription draft rather than draft-tao-netconf-data-export-capabilities in this proposed change?
Ups. Of course. You are right!

[ztr]: IMO, adaptive-subscription is the capability in device. For example, adjust the exporting rate based on the cpu usage. It’s the device self automation.
The congestion detection is on the collector side. I do not think there is need for the adaptive-subscription.
For example, when detecting congestion, just modify the subscription.

[Qin]: I have a few thoughts on this
1.       It is the job of the NMS rather than collector to modify the subscription or populate adaptive subscription policy.
2.       slow down export rating on the device can alleviate the bandwidth bottleneck between collectors and the device, but it doesn’t involve collector since the policy has already been enforced on the device.
I think this is what Tianran tries to clarify.
From: [email-masked]<mailto:[email-masked]> [mailto:[email-masked]]
Sent: Monday, January 18, 2021 11:38 PM
To: Qin Wu <[email-masked]<mailto:[email-masked]>>
Cc: Tianran Zhou <[email-masked]<mailto:[email-masked]>>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>; maqiufang (A) <[email-masked]<mailto:[email-masked]>>
Subject: RE: IETF109, YANG Push, udp-notif ,distributed-notif, data-export-capabilities, notification-messages and adaptive-subscription

Hi Qin,

Ø  [Qin]: If my understanding is correct, you propose to replace “udp” transport with “udp notif” and “https-notif” two new transports and add references to draft-ietf-netconf-udp-notif-01 and draft-ietf-netconf-https-notif-06 respectively?
Correct! 😊

Ø  [Qin]: I think you are referred to adaptive-subscription draft rather than draft-tao-netconf-data-export-capabilities in this proposed change?
Ups. Of course. You are right!

Best Wishes
Thomas

From: Qin Wu <[email-masked]<mailto:[email-masked]>>
Sent: Monday, January 18, 2021 2:42 PM
To: Graf Thomas, INI-NET-TCZ-ZH1 <[email-masked]<mailto:[email-masked]>>
Cc: Tianran Zhou <[email-masked]<mailto:[email-masked]>>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>; maqiufang (A) <[email-masked]<mailto:[email-masked]>>
Subject: RE: IETF109, YANG Push, udp-notif ,distributed-notif, data-export-capabilities, notification-messages and adaptive-subscription

Hi, Thomas:
发件人: [email-masked]<mailto:[email-masked]> [mailto:[email-masked]]
发送时间: 2021年1月18日 20:27
收件人: Qin Wu <[email-masked]<mailto:[email-masked]>>
抄送: Tianran Zhou <[email-masked]<mailto:[email-masked]>>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>
主题: RE: IETF109, YANG Push, udp-notif ,distributed-notif, data-export-capabilities, notification-messages and adaptive-subscription

Hi Qin,

Thanks a lot for the updated drafts. I reviewed them and have some clarifications and feedback.

In section "3 YANG Module" of "draft-tao-netconf-data-export-capabilities-03", "tcp, "udp" and "grpc" are described. Wouldn't it make sense to augment the proposed transport drafts, udp-notif and https-notif instead?  Depending on the capability the static subscription will be established. Without an exact mapping to the respective transport protocols, such a subscription would not be possible without manual intervention.

[Qin]: If my understanding is correct, you propose to replace “udp” transport with “udp notif” and “https-notif” two new transports and add references to draft-ietf-netconf-udp-notif-01 and draft-ietf-netconf-https-notif-06 respectively?

https://tools.ietf.org/html/draft-ietf-netconf-udp-notif-01#section-7<https://eur03.safelinks.protection.outlook.com/?url=https%3A%2F%2Ftools.ietf.org%2Fhtml%2Fdraft-ietf-netconf-udp-notif-01%23section-7&data=04%7C01%7CThomas.Graf%40swisscom.com%7Cb85939b914b44fb6bb9a08d8bc7e30ea%7C364e5b87c1c7420d9beec35d19b557a1%7C1%7C0%7C637466597453846647%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C1000&sdata=NOp%2F4i8kn%2B09NGjLzLSbnRPIiVgOMzV8yy%2BQ1UynJ1U%3D&reserved=0>
urn:ietf:params:xml:ns:yang:ietf-udp-notif

https://tools.ietf.org/html/draft-ietf-netconf-https-notif-06#section-7<https://eur03.safelinks.protection.outlook.com/?url=https%3A%2F%2Ftools.ietf.org%2Fhtml%2Fdraft-ietf-netconf-https-notif-06%23section-7&data=04%7C01%7CThomas.Graf%40swisscom.com%7Cb85939b914b44fb6bb9a08d8bc7e30ea%7C364e5b87c1c7420d9beec35d19b557a1%7C1%7C0%7C637466597453856591%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C1000&sdata=UFdbbXv7qC%2Btj%2Bxr1%2F3fU%2BxTOivucuqMcosUtfXtjTk%3D&reserved=0>
urn:ietf:params:xml:ns:yang:ietf-http-notif

If you wish, you can add me as contributor on draft-tao-netconf-data-export-capabilities.
[Qin]: Okay, sounds good, thanks for your support.

Hi Pierre,

In Section "4.1 Congestion Control"
https://tools.ietf.org/html/draft-ietf-netconf-udp-notif-01#section-4.1<https://eur03.safelinks.protection.outlook.com/?url=https%3A%2F%2Ftools.ietf.org%2Fhtml%2Fdraft-ietf-netconf-udp-notif-01%23section-4.1&data=04%7C01%7CThomas.Graf%40swisscom.com%7Cb85939b914b44fb6bb9a08d8bc7e30ea%7C364e5b87c1c7420d9beec35d19b557a1%7C1%7C0%7C637466597453856591%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C1000&sdata=WY4dLq3imEzwRf%2FHD5DSkZAMNqHQGiLrHMl5H9n9FPk%3D&reserved=0>

I suggest to modify the paragraph

"Hence the collector can notify the device to use a lower streaming rate. The interaction to control the streaming rate on the device is out of the scope of this document."

With

"Hence the collector can notify the device to use a lower streaming rate. A possible interaction to control the streaming rate is described in draft-tao-netconf-data-export-capabilities."

[Qin]: I think you are referred to adaptive-subscription draft rather than draft-tao-netconf-data-export-capabilities in this proposed change?

What do you think?

Best wishes
Thomas

From: Qin Wu <[email-masked]<mailto:[email-masked]>>
Sent: Thursday, January 14, 2021 3:16 PM
To: Graf Thomas, INI-NET-TCZ-ZH1 <[email-masked]<mailto:[email-masked]>>
Subject: RE: IETF109, YANG Push, udp-notif ,distributed-notif, data-export-capabilities, notification-messages and adaptive-subscription

Hi, Thomas:
Hope this email find you well.
Follow our discussion, I update two drafts accordingly, especially for data export capabilities draft, adding a usage example in the appendix.
Let me know if you are interested in joining them as coauthor.
Thanks!

-Qin
发件人: [email-masked]<mailto:[email-masked]> [mailto:[email-masked]]
发送时间: 2020年11月30日 13:06
收件人: Qin Wu <[email-masked]<mailto:[email-masked]>>; [email-masked]<mailto:[email-masked]>; Tianran Zhou <[email-masked]<mailto:[email-masked]>>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>; Guyunan <[email-masked]<mailto:[email-masked]>>
抄送: [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>; maqiufang (A) <[email-masked]<mailto:[email-masked]>>
主题: RE: IETF109, YANG Push, udp-notif ,distributed-notif, data-export-capabilities, notification-messages and adaptive-subscription

Hi Qin,

Thanks a lot. I sent you and the other the new. Looking forward to meet on Dec 7th 10:00 – 11:00 CET.

Best Wishes
Thomas

From: Qin Wu <[email-masked]<mailto:[email-masked]>>
Sent: Sunday, November 29, 2020 9:36 AM
To: Graf Thomas, INI-NET-TCZ-ZH1 <[email-masked]<mailto:[email-masked]>>; [email-masked]<mailto:[email-masked]>; Tianran Zhou <[email-masked]<mailto:[email-masked]>>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>; Guyunan <[email-masked]<mailto:[email-masked]>>
Cc: Arnold Matthias, INI-NET-TCZ-ZH1 <[email-masked]<mailto:[email-masked]>>; Nicoara Monica, INI-DNA-INF <[email-masked]<mailto:[email-masked]>>; maqiufang (A) <[email-masked]<mailto:[email-masked]>>
Subject: RE: IETF109, YANG Push, udp-notif ,distributed-notif, data-export-capabilities, notification-messages and adaptive-subscription

Thomas:
My time from Dec 2 to Dec 4 has been fully booked for a dedicated meeting. I have filled my available time in the doodle poll, thanks.

-Qin
发件人: [email-masked]<mailto:[email-masked]> [mailto:[email-masked]]
发送时间: 2020年11月27日 19:49
收件人: Qin Wu <[email-masked]<mailto:[email-masked]>>; [email-masked]<mailto:[email-masked]>; Tianran Zhou <[email-masked]<mailto:[email-masked]>>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>; Guyunan <[email-masked]<mailto:[email-masked]>>
抄送: [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>
主题: RE: IETF109, YANG Push, udp-notif ,distributed-notif, data-export-capabilities, notification-messages and adaptive-subscription

Hi Tianran, Qin, Peng, Yunan, Pierre and Paolo,

Once more my apology about the cancelation of last meeting.

Could you please choose the dates/times which suit you best for next week and the week after.
https://doodle.com/poll/f8yxdz2qzgvhu975<https://eur03.safelinks.protection.outlook.com/?url=https%3A%2F%2Fdoodle.com%2Fpoll%2Ff8yxdz2qzgvhu975&data=04%7C01%7CThomas.Graf%40swisscom.com%7Cb85939b914b44fb6bb9a08d8bc7e30ea%7C364e5b87c1c7420d9beec35d19b557a1%7C1%7C0%7C637466597453866549%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C1000&sdata=28u5R7W4ynRpb5bBQEQxcnJm%2BdX3cGiCyGI22BPSOHc%3D&reserved=0>

The times are in CET (CST is +7). All times are in the morning CET, late afternoon CST. I hope this suits better.

Best Wishes
Thomas

From: Graf Thomas, INI-NET-TCZ-ZH1
Sent: Wednesday, November 18, 2020 9:35 AM
To: Qin Wu <[email-masked]<mailto:[email-masked]>>; Peng Liu <[email-masked]<mailto:[email-masked]>>; Tianran Zhou <[email-masked]<mailto:[email-masked]>>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>; Guyunan <[email-masked]<mailto:[email-masked]>>
Cc: Arnold Matthias, INI-NET-TCZ-ZH1 <[email-masked]<mailto:[email-masked]>>; Nicoara Monica, INI-DNA-INF <[email-masked]<mailto:[email-masked]>>
Subject: IETF109, YANG Push, udp-notif ,distributed-notif, data-export-capabilities, notification-messages and adaptive-subscription

Hi Tinaran, Qin, Peng, Yunan, Pierre and Paolo,

As a co-author of udp-notif and distributed-notif, I would like to take the chance here at IETF 109 in a break out session to understand your view points and motivations an regards to the following points,

-      How to handle YANG push encoding code points
-      How to handle transport type (UDP vs HTTPS)
-      How to handle congestion avoidance
-      How to handle "Domain Observation ID" in transport, congestion avoidance and notification-message

Involving the following drafts:

An HTTPS-based Transport for Configured Subscriptions
https://tools.ietf.org/html/draft-ietf-netconf-https-notif-06<https://eur03.safelinks.protection.outlook.com/?url=https%3A%2F%2Ftools.ietf.org%2Fhtml%2Fdraft-ietf-netconf-https-notif-06&data=04%7C01%7CThomas.Graf%40swisscom.com%7Cb85939b914b44fb6bb9a08d8bc7e30ea%7C364e5b87c1c7420d9beec35d19b557a1%7C1%7C0%7C637466597453866549%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C1000&sdata=N%2F0Dmnr23JikEEWN5vRpFZgOjDjb3AjL3OJOU9zMa8I%3D&reserved=0>

UDP-based Transport for Configured Subscriptions
https://tools.ietf.org/html/draft-ietf-netconf-udp-notif-01<https://eur03.safelinks.protection.outlook.com/?url=https%3A%2F%2Ftools.ietf.org%2Fhtml%2Fdraft-ietf-netconf-udp-notif-01&data=04%7C01%7CThomas.Graf%40swisscom.com%7Cb85939b914b44fb6bb9a08d8bc7e30ea%7C364e5b87c1c7420d9beec35d19b557a1%7C1%7C0%7C637466597453876515%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C1000&sdata=P2bzT1DCntkdrSL4IBexyDJeAQsmy3%2FACldYp1bd9C0%3D&reserved=0>

Subscription to Distributed Notifications
https://tools.ietf.org/html/draft-ietf-netconf-distributed-notif-01<https://eur03.safelinks.protection.outlook.com/?url=https%3A%2F%2Ftools.ietf.org%2Fhtml%2Fdraft-ietf-netconf-distributed-notif-01&data=04%7C01%7CThomas.Graf%40swisscom.com%7Cb85939b914b44fb6bb9a08d8bc7e30ea%7C364e5b87c1c7420d9beec35d19b557a1%7C1%7C0%7C637466597453876515%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C1000&sdata=ed0gMpI50B3amc7W1AXs9bIhJOoQqjNayGkvDpS2IoA%3D&reserved=0>

YANG Modules for describing System Capabilities and Yang-Push
https://tools.ietf.org/html/draft-ietf-netconf-notification-capabilities-13<https://eur03.safelinks.protection.outlook.com/?url=https%3A%2F%2Ftools.ietf.org%2Fhtml%2Fdraft-ietf-netconf-notification-capabilities-13&data=04%7C01%7CThomas.Graf%40swisscom.com%7Cb85939b914b44fb6bb9a08d8bc7e30ea%7C364e5b87c1c7420d9beec35d19b557a1%7C1%7C0%7C637466597453886466%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C1000&sdata=TOCy0q1MCsSk110dTpRUcT1rmXWzn6n4TIlTifcYSrs%3D&reserved=0>

Telemetry Data Export capability
https://tools.ietf.org/html/draft-tao-netconf-data-export-capabilities-01<https://eur03.safelinks.protection.outlook.com/?url=https%3A%2F%2Ftools.ietf.org%2Fhtml%2Fdraft-tao-netconf-data-export-capabilities-01&data=04%7C01%7CThomas.Graf%40swisscom.com%7Cb85939b914b44fb6bb9a08d8bc7e30ea%7C364e5b87c1c7420d9beec35d19b557a1%7C1%7C0%7C637466597453886466%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C1000&sdata=FC0XNXWkHoerVip15oH40gWQmDsFsOsGkn%2FsWm3FNCw%3D&reserved=0>

Notification Message Headers and Bundles
https://tools.ietf.org/html/draft-ietf-netconf-notification-messages-08<https://eur03.safelinks.protection.outlook.com/?url=https%3A%2F%2Ftools.ietf.org%2Fhtml%2Fdraft-ietf-netconf-notification-messages-08&data=04%7C01%7CThomas.Graf%40swisscom.com%7Cb85939b914b44fb6bb9a08d8bc7e30ea%7C364e5b87c1c7420d9beec35d19b557a1%7C1%7C0%7C637466597453896422%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C1000&sdata=Og%2FdX%2BKs9NL2xXHESECk2u%2FaayjolAkvGdJ62oa1gP4%3D&reserved=0>

Adaptive Subscription to YANG Notification (10 min)
https://tools.ietf.org/html/draft-wang-netconf-adaptive-subscription-02<https://eur03.safelinks.protection.outlook.com/?url=https%3A%2F%2Ftools.ietf.org%2Fhtml%2Fdraft-wang-netconf-adaptive-subscription-02&data=04%7C01%7CThomas.Graf%40swisscom.com%7Cb85939b914b44fb6bb9a08d8bc7e30ea%7C364e5b87c1c7420d9beec35d19b557a1%7C1%7C0%7C637466597453896422%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C1000&sdata=jlvxdVJRf0CYLI4IUWIswtUlCIC1YSJBnhfYjcYQ%2B5M%3D&reserved=0>

My aim is hat we hadn't the chance to talk together about these points and if possible to establish a common understanding and from there even define the next steps and how we can improve our alignment from now on.

I am available on Thursday between 09:30 AM and 18:30 CET. And on Friday between 17:00 – 18:30 CET. I suggest a 90 Minutes slot.

Please let me know if that makes sense to you and when you like to meet.

Best wishes
Thomas Graf
____________________________________________________________________________
Network Engineer
Datacenter Functions
Telefon +41-58-223 84 01
Mobile   +41-79-728 80 12
[email-masked]<mailto:[email-masked]>
____________________________________________________________________________
Swisscom (Schweiz) AG
IT, Network & Infrastructure
Datacenter Functions
Binzring 17
8045 Zürich
www.swisscom.com<http://www.swisscom.com/>
Postadresse:
Binzring 17
8045 Zürich